/*
*               TeX Device Driver DVIOUT, DVIPRT 
*               MS Windows  TrueType font g
*
*                            ttfont.h
*
*                    14 Nov. 1993  by I.Matsuda
*/

/*
 *  .tti file header
 */
typedef struct {
	uint CodeTable;			/* JIS -> Glyph Index ϊe[u
							   ̐擪AhX */
	uint MaxJIS;			/* JIS (R[h) ̍ől */
	uint unitsPerEm;		/* Wf[^̐x */
	int xMin;				/* Wf[^(x)̍ŏl (_) */
	int yMin;				/* Wf[^(y)̍ŏl (_) */
	uint maxPoints;			/* PɊ܂܂ő̐_ */
	uint maxContours;		/* PɊ܂܂ő̗֊s */
	ulong IndexBase;		/* Glyph Index -> Offset ϊe[u
							   ̐擪AhX */
	ulong GlyphBase;		/* Glyph f[^̐擪AhX */
} TT_INFO;

/*
 *   TT font ̊e
 */
#if	0
typedef struct {
	uchar unitsPerEm[2];		/* Wf[^̐x */
	uchar CmapBase[4];			/* Char -> Glyph Index   ϊe[u̐擪 */
	uchar IndexBase0[4];		/* Glyph Index -> Offset ϊe[u̐擪 */
	uchar IndexBase[4];			/* Glyph Index -> Offset ϊe[u̐擪 */
	uchar GlyphBase[4];			/* Glyph f[^̐擪 */
	uchar HmtxBase[4];			/* gNXe[u̐擪 */
	uchar numOfHMetrics[2];		/* Number of hMetrtic entries in 'hmtx' */
	uchar C2IndexFormat[2];		/* cmap -> index e[ũtH[}bg */
	uchar FirstCode[2];			/* First character code of subrange */
	uchar EntryCount[2];		/* Number of character codes in subrange */
	uchar indexToLocFormat[2];	/* index -> glyph e[ũtH[}bg */
	uchar xMin[2];				/* Wf[^(x)̍ŏl (_) */
	uchar yMin[2];				/* Wf[^(y)̍ŏl (_) */
	uchar xMax[2];				/* Wf[^(x)̍ől */
	uchar yMax[2];				/* Wf[^(y)̍ől */
	uchar f_have_tfm[2];		/* Ή tfm ݂邩? */
	uchar f_type [2];			/* R[h^  */
} CMTT_INFO;
#else
typedef struct {
	uint unitsPerEm;		/* Wf[^̐x */
	ulong CmapBase0;		/* Char -> Glyph Index   ϊe[u̐擪 */
	ulong CmapBase;			/* Char -> Glyph Index   ϊe[u̐擪 */
	ulong IndexBase;		/* Glyph Index -> Offset ϊe[u̐擪 */
	ulong GlyphBase;		/* Glyph f[^̐擪 */
	ulong HmtxBase;			/* gNXe[u̐擪 */
	uint numOfHMetrics;		/* Number of hMetrtic entries in 'hmtx' */
	uint C2IndexFormat;		/* cmap -> index e[ũtH[}bg */
	uint FirstCode;			/* First character code of subrange */
	uint EntryCount;		/* Number of character codes in subrange */
	uint indexToLocFormat;	/* index -> glyph e[ũtH[}bg */
	int xMin;				/* Wf[^(x)̍ŏl (_) */
	int yMin;				/* Wf[^(y)̍ŏl (_) */
	int xMax;				/* Wf[^(x)̍ől */
	int yMax;				/* Wf[^(y)̍ől */
	int f_have_tfm;			/* Ή tfm ݂邩? */
	int f_type;				/* R[h^
						    f_type &  1 = 0  Use 2 byte table (Format 4)
                                          1  Use 1 byte table (Format 0)
                            f_type & 14 = 0  BoKoMa translation
                                          2  Simple translation
                                          4  Symbol translation
							f_type > 256     Code Page
							*/
} CMTT_INFO;
#endif

/*
 *  Otf[^ێ\
 */
typedef struct {
	uint *end_pts;		/* e֊s̏I_Xg */
	uchar *flist;		/* _̃tO */
	int *xlist;			/* x W */
	int *ylist;			/* y W */
	int num_cts;			/* ֊s̐ */
	int num_pts;			/* _̐ */
	int cp;					/* ֊s̃|C^ */
	int cc;					/* _̃|C^ */
	ulong IndexBase;		/* Glyph Index -> Offset ϊe[u̐擪 */
	ulong GlyphBase;		/* Glyph f[^̐擪 */
	uint indexToLocFormat;	/* index -> glyph e[ũtH[}bg */
	uint unitsPerEm;		/* Wf[^̐x */
} GLYPH;

/*
 * UNPACKING Constants
*/
#define ONCURVE             0x01
#define XSHORT              0x02
#define YSHORT              0x04
#define REPEAT_FLAGS        0x08 /* repeat flag n times */
/* IF XSHORT */
#define SHORT_X_IS_POS      0x10 /* the short vector is positive */
/* ELSE */
#define NEXT_X_IS_ZERO      0x10 /* the relative x coordinate is zero */
/* ENDIF */
/* IF YSHORT */
#define SHORT_Y_IS_POS      0x20 /* the short vector is positive */
/* ELSE */
#define NEXT_Y_IS_ZERO      0x20 /* the relative y coordinate is zero */
/* ENDIF */
/* 0x40 & 0x80              RESERVED
** Set to Zero
**
*/
/*
 * Composite glyph constants
 */
#define COMPONENTCTRCOUNT           -1      /* ctrCount == -1 for composite */
#define ARG_1_AND_2_ARE_WORDS       0x0001  /* if set args are words otherwise they are bytes */
#define ARGS_ARE_XY_VALUES          0x0002  /* if set args are xy values, otherwise they are points */
#define ROUND_XY_TO_GRID            0x0004  /* for the xy values if above is true */
#define WE_HAVE_A_SCALE             0x0008  /* Sx = Sy, otherwise scale == 1.0 */
#define NON_OVERLAPPING             0x0010  /* set to same value for all components */
#define MORE_COMPONENTS             0x0020  /* indicates at least one more glyph after this one */
#define WE_HAVE_AN_X_AND_Y_SCALE    0x0040  /* Sx, Sy */
#define WE_HAVE_A_TWO_BY_TWO        0x0080  /* t00, t01, t10, t11 */
#define WE_HAVE_INSTRUCTIONS        0x0100  /* instructions follow */


#define tag_FontHeader			0x68656164		/* 'head' */
#define tag_HoriHeader			0x68686561		/* 'hhea' */
#define tag_HorizontalMetrics	0x686d7478		/* 'hmtx' */
#define tag_IndexToLoc			0x6c6f6361		/* 'loca' */
#define tag_GlyphData			0x676c7966		/* 'glyf' */
#define tag_CharToIndexMap		0x636d6170		/* 'cmap' */
#define tag_NamingTable			0x6e616d65		/* 'name' */

int GetWinTTGlyph(char *, int, struct PREAMBLE_REC *, int);
