/*
*               TeX Device Driver DVIOUT, DVIPRT 
*               ̋ỹAEgCtHgg
*
*                            vfont.h
*
*	1991-92  by T.Minagawa
*	6 June 1992 : slightly modified to utilize tpic functions by Oh-Yeah?
*	1 Sept 1992 : slightly modified for version check by sempa.
*  12 Nov  1992 : modified for JGfont(3D-Bezier) by Naochan!
*  27 NOV  1992 : slightly modified for by Yakumo
*  14 Nov. 1993 : modified for TT font by I.Matsuda
*/

#define	VFN_VERSION	"2"	/* vfño[W݂͐̂Ń`FbN */
#define VER_LEN 4	/* version`FbN̕obt@̒ */

typedef enum {
	V_FLUSH = -2, V_ERROR = -1, V_CLOSE = 0, V_OPEN = 1
} VF_FLAG;

/* check flag for vector font */
typedef enum {
	CLEAR_BUF, KEEP_BUF, GET_DATA
} GET_TEN_SW;

/* get_ten p̃tO */

#define MAX_VFONT 256 /* o^ł vec font ̍ő吔 */
#define NAMELEN 32	/* jfm file name pobt@̃TCY */
#define MAX_VALUE 0x3ff	/* xNgtHgWf[^̍ől
						 * W10bitsŋLqĂ̂ŁA
						 * 0x3ff őlɂȂ */
#define MAX_RANGE 0x400L
#define MAX_CODE 4417	/* xNgtHgR[h̍ől */
#define BUFSIZE 256	/* vfn file ǂݎpobt@̃TCY */
#ifdef VFTPIC
#define DEF_THIN 100	/* thin p[^̃ftHg */
#else
#define DEF_THIN 50	/* thin p[^̃ftHg */
#endif
#define	MAX_THIN 3
#define DELIM1 ','	/* vfn file ̍ڊԋ؂ */
#define DELIM2 ';'	/* vfn file ̍ړ؂ */

#define VF_BUF_SIZE 256	/* xNgtHgWJpǂ݃obt@*/
#define V_FONT struct _v_font

struct _v_font {
/*	char v_font_name[MAXPATH];	 vector font name     */
	char *v_font_name;			/* vector font name     */
	VF_FLAG status;	/* tHgt@C̏Ԃ     */
	int v_fh[3];	/* PAQ̃tHgt@C
					 * ̃t@Cnh               */
	int yoffset;	/* ItZbg               */
	int width_adj;	/* ̃AWXg */
	int height_adj;	/* ̃AWXg */
	int font_type;	/* tHg̎ (ZS_FONT,JG_FONT,VFD_FONT) */
};

#if defined(USE_WINFONT) && !defined(_INC_WINDOWS)
# if 0 
typedef struct _FIXED {
    unsigned short fract;
    short value;
} FIXED;
# else
#define	FIXED int
# endif

typedef struct _MAT2 {
     FIXED  eM11;
     FIXED  eM12;
     FIXED  eM21;
     FIXED  eM22;
} MAT2;
#undef FIXED
#endif

#define V_JFM struct v_jfm

struct v_jfm {
	char name[NAMELEN];	/* JFM t@C̖O              */
	int font_no;	/* gpxNgtHg̔ԍ          */
	int long_wide;	/* ́ÂɊւ                  */
	int slant;	/* X΂Ɋւ                        */
	int draw_sw;	/* tHg`@ĨXCb`          */
	int threshold;	/* `@؂芷̂l              */
	int thin, _xfat, _yfat;	/* tHg̐p[^            */
	int far *novec;	/* vec font sgpTCYXgւ̃|C^ */
	int rotation;	/* tHg]tO                      */
	int f_goth;	/* ^SVbN̕ύX 0:ύXȂ,1:W,2:^SVbN*/
	V_JFM *next;	/* ̃tHgւ̃|C^            */
#ifdef	USE_WINFONT
	MAT2 mat;
#endif
};

/* WJW[hōsȂAfine[hōsȂ̃tO */
typedef enum {
	STD_MODE, FINE_MODE
} DRAW_MODE;

/* W[h̏ꍇ̕`@ */
typedef enum {
	VTRACE, FILL, BOTH
} DRAW_TYPE;

typedef struct {
	int x, y;
} LOCATE;

extern V_JFM *vjfm_top;
extern V_FONT *vfont[];
extern struct _v_font dummy;

#ifdef	USE_WINFONT
void GetWinjTTGlyph(V_JFM *, int, int, struct PREAMBLE_REC *, int, char *);
void GetWinjTTMetric(V_JFM *, int *, int *, char *);
V_JFM *check_wintt(char *);
V_JFM *get_vjfm(int);
#endif

#ifdef	USE_ETF
#define	ETF_VERSION		0
#define	ETF_SUBVER		5

typedef struct {
	FONT_INFO * font;
	unsigned int code;
	unsigned int tfm_width;
	unsigned int top;
	unsigned int end;
	unsigned int lsb;
} ETF_INFO;

typedef struct {
	int name;
	int resol;
	int type;
	int num;
	int Hoffset;
	int Coffset;
} FONT_INDEX;

void SetETFindex(FONT_INFO *, int, int, int, int, int);

extern BOOL f_make_etf;
extern BOOL f_make_jttetf;

#define ETF_IMAGE struct ETF_IMAGE_REC

struct ETF_IMAGE_REC {
	ETF_IMAGE *next;
	int flag;
	char image[2];
};

#define	ETT_FONT	struct ETT_FONT_REC

struct ETT_FONT_REC {
	int tfm_width;
	int tfm_height;
	int tfm_depth;

	short int unitsPerEm;
	short int xMin;
	short int yMin;

	short int extra;
	short int yoffset;

	short int width_adj;
	short int height_adj;

	short int f_goth;

	short int long_wide;
	short int slant;
	short int draw_sw;
	short int threshold;
	short int thin;
	short int _xfat;
	short int _yfat;
	short int rotation;
};
#endif

#define	CID	-2
